﻿(function () {
	'use strict';

	// Factory name is handy for logging
	var serviceId = 'datarepo.commonrepo';

	angular.module('app').factory(serviceId, ['common', DataRepositoryCommon]);

	function DataRepositoryCommon(common) {
		var $q = common.$q;
		var testobj = {
			obj1: '',
			obj2: ''
		}
		var specializationDetails = {
		    key: "",
		    value: ""
		};

		var searchInfo = {
		    doctorName:'',
		    doctorLoc :'',
		    doctorSpec:'',
		    doctorLat :'',
		    doctorLng :'',
		    doctorIsAuto: '',
		    searchBy: '',
		    firstTime: true,
            pageindex:0
		}

		var facebookUserDetails = {
            fbId:'',
            fbName: '',
            fbFirstName: '',
            fbLastName: '',
            fbVerified: '',
            fbGender: '',
            fbBirthday: '',
            fbEmail: '',
            fbRelationship:''

		}
		var FbUserData;
		var kare4uregisteredUserData;
		var searchedResultForSuggestion;
		var favouriteListInfo = { specializationId: "", specializationName: "", cityId: "", cityName: "", cityAreaId: "", cityAreaName: "", doctorId: "", doctorName: "" };

		var selectedDoctorInfo = {
		    providerID: '',
		    providerName:''

		}
		var commonDropdownList = new Array();
		var Geolocationstatus = '';
		var locationErrorstatus = false;
		var reposearchedResult;
		var service = {
			saveTest: saveTest,
			getTest: getTest,
			saveAutocompleteResult: saveAutocompleteResult,
			getAutocompleteResult: getAutocompleteResult,
			saveProviderID: saveProviderID,

            //registration module starts
			saveSpecializationDetails: saveSpecializationDetails,
		    getSpecializationDetails: getSpecializationDetails,
		    saveFavouriteListFilterInfo: saveFavouriteListFilterInfo,
		    getFavouriteListFilterInfo: getFavouriteListFilterInfo,
		    saveGeolocationstatus: saveGeolocationstatus,
		    getGeolocationstatus: getGeolocationstatus,
		    getProviderID: getProviderID,
		    getCommonDropDownData: getCommonDropDownData,
		    setCommonDropDownData: setCommonDropDownData,
		    saveSearchedResult: saveSearchedResult,
		    getSearchedResult: getSearchedResult,
		    setStatusOfErrorCode: setStatusOfErrorCode,
		    getStatusOfErrorCode: getStatusOfErrorCode,
		    saveAutocompleteResultForSuggestion: saveAutocompleteResultForSuggestion,
		    getAutocompleteResultForSuggestion: getAutocompleteResultForSuggestion,
		    setFacebookDeatils: setFacebookDeatils,
		    getFacebookDeatils: getFacebookDeatils,
		    saveFacebookUserDetails: saveFacebookUserDetails,
		    getFacebookUserDetails: getFacebookUserDetails
		    //saveKare4uRegisterdUserDetails: saveKare4uRegisterdUserDetails,
		    //getKare4uRegisterdUserDetails: getKare4uRegisterdUserDetails
            //registration module ends
		};

		return service;

		function saveFacebookUserDetails(fbuserdata) {
		    FbUserData = fbuserdata;
		}
		//function saveKare4uRegisterdUserDetails(kare4uuserdata) {
		//    kare4uregisteredUserData = kare4uuserdata;
		//}
		function getFacebookUserDetails() {

		    return FbUserData;
		}
		//function getKare4uRegisterdUserDetails() {

		//    return kare4uregisteredUserData;
		//}
		
		function setFacebookDeatils(fbdata) {
		    facebookUserDetails.fbId = fbdata.id;
		    facebookUserDetails.fbName = fbdata.name;
		    facebookUserDetails.fbFirstName = fbdata.first_name;
		    facebookUserDetails.fbLastName = fbdata.last_name;
		    facebookUserDetails.fbVerified = fbdata.verified;
		    facebookUserDetails.fbGender = fbdata.gender;
		    facebookUserDetails.fbBirthday = fbdata.birthday;
		    facebookUserDetails.fbEmail = fbdata.email;
		    facebookUserDetails.fbRelationship = fbdata.relationship_status;
		}
		function getFacebookDeatils() {

		    return facebookUserDetails;
		}

		function getTest() {
		
			return testobj;
		}
		function getCommonDropDownData() {

		    return commonDropdownList;
		}
		function setCommonDropDownData(commonList) {
		    commonDropdownList = [];
		    for (var i = 0; i < commonList.length; i++) {
		        //x.key = data[i].value;
		        //x.value = data[i].key;
		        //xxz.push(x);
		        commonDropdownList.push({ key: commonList[i].key, value: commonList[i].value });
		    }

		   
		}

		function saveAutocompleteResultForSuggestion(tempsearchedResultForSuggestion) {
		    searchedResultForSuggestion = tempsearchedResultForSuggestion;
		}

		function getAutocompleteResultForSuggestion() {
		    return searchedResultForSuggestion;
		}
		function setStatusOfErrorCode(errorStatus) {
		    locationErrorstatus = errorStatus;
		}
		function getStatusOfErrorCode() {
		    return locationErrorstatus ;
		}

		function saveTest(docname, docspec) {

			testobj.obj1 = docname;
			testobj.obj2 = docspec;


		}

		function saveSearchedResult(searchedresult) {
		    reposearchedResult = "";
		    reposearchedResult = searchedresult;
		}
		function getSearchedResult() {
		    return reposearchedResult;
		}

	    /* Search */
		function saveAutocompleteResult(srchInfo) {
		    //alert("Save auto comp res="+name+" "+loc+" "+spec+" "+lat+" "+lng+" "+isAutoCom);
		    searchInfo.doctorName = srchInfo.doctorName;
		    searchInfo.doctorLoc = srchInfo.doctorLoc;
		    searchInfo.doctorSpec =srchInfo.doctorSpec ;
		    searchInfo.doctorLat = srchInfo.doctorLat ; 
		    searchInfo.doctorLng = srchInfo.doctorLng;
		    searchInfo.doctorIsAuto = srchInfo.doctorIsAuto;
		    searchInfo.searchBy = srchInfo.searchBy;
		    searchInfo.firstTime = srchInfo.firstTime;
		    searchInfo.pageindex = srchInfo.pageindex;
		}
		function getAutocompleteResult() {
		    return searchInfo;
		   
		}
	    /*Rebook appointment*/
		function saveProviderID(providerID, providerName) {
		    //alert(providerID);
		    selectedDoctorInfo.providerID = providerID;
		    selectedDoctorInfo.providerName = providerName;
		}
		function getProviderID() {
		    //alert(providerID);
		    return selectedDoctorInfo;
		}
	    //region registration starts
		function saveSpecializationDetails(specializationInfo) {
		    //console.log(specializationInfo);
		    specializationDetails.key = specializationInfo.key;
		    specializationDetails.value = specializationInfo.value;
		}
		function getSpecializationDetails() {
		    return specializationDetails;
		}
		function saveFavouriteListFilterInfo(saveFavouriteInfo) {
		    favouriteListInfo = saveFavouriteInfo;
		    //alert("Datarepo accessed successfully");
		    console.log(favouriteListInfo);
		}
		function getFavouriteListFilterInfo() {
		    return favouriteListInfo;
		}

		function saveGeolocationstatus(geolocationstatus) {
		    Geolocationstatus = geolocationstatus;
		}
		function getGeolocationstatus() {
		    return Geolocationstatus ;
		}
	    //region registration ends

		//#region Internal Methods        

		//#endregion
	}

})();