﻿(function () {
    'use strict';

    // Factory name is handy for logging
    var serviceId = 'datarepositories';

    // Define the factory on the module.
    // Inject the dependencies. 
    // Point to the factory definition function.
    // TODO: replace app with your module name
    angular.module('app').factory(serviceId, ['$injector', datarepositories]);

    function datarepositories($injector) {
        // Define the functions and properties to reveal.
        var service = {
            getDataRepo: getDataRepo
        };

        return service;

        // Get named Repository Ctor (by injection), new it, and initialize it
        function getDataRepo(dataRepoName) {
            var fullDataRepoName = 'datarepo.' + dataRepoName.toLowerCase();
            var Repo = $injector.get(fullDataRepoName);
            return Repo;
        }

        //#region Internal Methods        

        //#endregion
    }
})();