(function () {
    'use strict';
    var controllerId = 'registration';
    angular.module('app').controller(controllerId, ['common', 'datacontext', '$scope', '$location',
        '$rootScope', 'userService', 'datarepo', 'phonegapFeatures','registeredUserInfo', registration]);

    function registration(common, datacontext, $scope, $location, $rootScope, userService, datarepo, phonegapFeatures, registeredUserInfo) {
        var getLogFn = common.logger.getLogFn;
        var log = getLogFn(controllerId);
        var logSuccess = getLogFn(controllerId, 'success');
        var logError = getLogFn(controllerId, 'error');

        var vm = this;

        vm.maritalStatus = ['Single', 'Married', 'Married with kids'];
        vm.doctorSpecializations = ['Allergist', 'Cardiologist', 'Dermatologist', 'Psychiatrist', 'Urologist', 'Internal Medicine', 'Gynecologist', 'Obstetrician', 'Nurse-Midwifery'];
        vm.title = 'Registration';
        //vm.registrationData = null;
        vm.selectedCategory = "";
        vm.selectedMaritalStatus = vm.maritalStatus[0];
        vm.specializationsDetails = [];
        vm.searchLocationNearBy = true;
        vm.doctorsInfoData = [];
        vm.searchLocationNearBy = true;
        vm.searchLocationByCity = false;
        vm.searchLocation = 'searchNearBy';
        vm.searchResultCity = [];
        vm.doctorSetupMode = "";
        vm.infoForAddMoreDoctorsPage;
        vm.registrationMessage = "";
        vm.showMessage = '';
        vm.facebookCredentials = null;
        vm.customer = {
            userLogin: '',
            password:''
        }
        $scope.consumer = {
            UserLogin: '',
            FirstName: '',
            Contact: '',
            Password:'',
            DateOfBirth: ''

        };

        vm.registrationStatus = {
            userLoginStatus: false,
            passwordStatus: false,
            contactStatus: false
        }

        document.addEventListener('deviceready', function () {
            // window.fbAsyncInit = function() {
            // susant appId: '1413722992216525',
            console.log('here');

            FB.init({
                appId: '506897312747947',
                nativeInterface: CDV.FB,
                //status: true, // check login status
                // cookie: true, // enable cookies to allow the server to access the session
                // xfbml: true,
                useCachedDialogs: false
            });

            FB.getLoginStatus(function (response) {
                console.log(response.status);
                if (response.status === 'connected') {
                    $rootScope.isBusy = false;
                    callAPI();
                } else if (response.status === 'not_authorized') {
                    $rootScope.isBusy = false;
                } else {
                    $rootScope.isBusy = false;
                }
            });

            //FB.init({
            //    appId: '506897312747947',
            //    nativeInterface: CDV.FB,

            //    useCachedDialogs: false
            //});
            //FB.Event.subscribe('auth.statusChange', handleStatusChange);
            // FB.getLoginStatus(handleStatusChange);
            //FB.getLoginStatus(function (response) {
            //    console.log(response.status);
            //    if (response.status === 'connected') {
            //        // connected
            //        //callAPI();
            //    } else if (response.status === 'not_authorized') {
            //        // not_authorized
            //        // login();
            //    } else {
            //        // not_logged_in
            //        //login();
            //    }
            //});
            window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, onRequestFileSystemSuccess, null);
        });

        function onRequestFileSystemSuccess(fileSystem) {
           
            var entry = fileSystem.root;
            entry.getDirectory("kare4U", { create: true, exclusive: false }, onGetDirectorySuccess, onGetDirectoryFail);
        }

        function onGetDirectorySuccess(dir) {
            //alert("onRequestFileSystemSuccess");           
        }

        function onGetDirectoryFail(error) {            
        }

        function callAPI() {
            console.log('Welcome back!  Fetching your information... ');
            FB.api('/me', function (response) {
                //console.log('Good to see you, Connected ' + response.name + '.');
               // console.log(response);
                var output = '';
                output += '<img src="' + response.picture.data.url + '" width="25" height="25"></img>';
                output += ' ' + response.first_name;
               // console.log(output);

                vm.myinfo = output;
            });
        }

        function testAPI() {
            $rootScope.isBusy = true;
       
            //FB.api('/me', { fields: "id,name,first_name,picture,birthday,email,gender,last_name,relationship_status,verified,username,link" }, function (response) {
            FB.api('/me',
               { fields: "id,name,first_name,picture,birthday,email,gender,last_name,relationship_status,verified" },
               function (response) {                  
                   var Email = response.email;
                   var pictureUrl = response.picture.data.url;
                   datarepo.commonrepo.setFacebookDeatils(response);
                  
                   return datacontext.registration.getFacebookUserDetails(response).then(function (response) {
                       datarepo.commonrepo.saveFacebookUserDetails(response);
                       if (!response.userExists) {                         
                          // common.gaTrackEvent('Facebook Login', 'Click Login With FB', 'Facebook');
                           userService.getLoggedInUser().then(function () {                             
                               userService.userImageSrc = pictureUrl;
                               logSuccess(response.message, '', true);                              
                               $rootScope.isBusy = false;
                               common.gaTrackEvent('Facebook Login', 'Click Login With FB', 'Facebook');                              
                               $location.path("/login_with_fb");
                           });
                       }
                       else {
                           $rootScope.isBusy = false;                           
                           if (response.success) {                              
                               userService.userImageSrc = pictureUrl;                              
                               userService.getLoggedInUser().then(function () {                                  
                                   logSuccess(response.message, '', true);
                                   common.gaTrackEvent('Facebook Login', 'Click Login With FB', 'Facebook');                                 
                                   $location.path('/dashboard');
                               });
                           }
                           else {                               
                               userService.userImageSrc = '';
                               document.getElementById("FblogmsgAlrt").className = " alert alert-info show";
                               vm.fbLoginMsg = '<p>Looks like Is ' + ' < strong >' + Email + '</strong>' + ' already registerded mannually. To use your facebook login please login to the app using ' + ' < strong >' + Email + '</strong>' + ' and change the email adress.</p>';
                                                           
                               logError(response.message, '', true);
                           }
                       }

                   }, function (response) {                      
                       userService.userImageSrc = '';
                      
                       alert(response.message);
                       $rootScope.isBusy = false;
                   });


               
               });
           
            $rootScope.isBusy = false;
        }
        //  function login() {
        vm.FblogmsgAlrtClose = function () {
            document.getElementById("FblogmsgAlrt").className = "alert alert-info hide";
        }
        vm.loginWithFacebook = function () {
           
           
            if (!window.cordova) {
                var response = {
                    id: 773764012633923141,
                    name: "Susanta",
                    first_name: "Susanta",
                    last_name: "Patra",
                    verified: true,
                    gender: "male",
                    birthday: "",
                    email: "susanta.patra@kare4u.in"
                }
               

                datarepo.commonrepo.setFacebookDeatils(response);
                return datacontext.registration.getFacebookUserDetails(response).then(function (response) {
                    datarepo.commonrepo.saveFacebookUserDetails(response);
                    if (!response.userExists) {

                        userService.getLoggedInUser().then(function () {
                            logSuccess(response.message, '', true);
                            $location.path("/login_with_fb");

                        });


                    }
                    else {
                        if (response.success) {

                            userService.getLoggedInUser().then(function () {
                                logSuccess(response.message, '', true);
                                $location.path('/dashboard');

                            });
                        }
                        else {
                            document.getElementById("FblogmsgAlrt").className += "in";
                            vm.fbLoginMsg = '<p>Looks like Is ' + ' < strong >' + response.email + '</strong>' + ' already registerded mannually. To use your facebook login please login to the app using ' + ' < strong >' + response.email + '</strong>' + ' and change the email adress.</p>';
                            logError(response.message, '', true);
                        }
                    }

                }, function (response) { });

            }
            $rootScope.isBusy = true;
            console.log("login called");
            FB.login(function (response) {
                if (response.authResponse) {
                    // connected
                    $rootScope.isBusy = true;
                    testAPI();
                } else {
                    // cancelled
                }
                //  }, { scope: 'email,user_birthday,user_mobile_phone' }, { perms: 'user_address, user_mobile_phone' });

            }, { scope: 'email' });
            ////   FB.login(null, { scope: 'email,user_likes,user_birthday,user_hometown,user_location,user_relationships' }, { perms: 'user_address, user_mobile_phone' });

        }

        //vm.myfriend = function () {
        //    alert("myfriend called");
        //    console.log("myfriend");
        //    //FB.api('/me/friends', function (response) {
        //    FB.api('/me/friends', { fields: 'id, name, picture' }, function (response) {
        //        if (response.error) {
        //            alert(JSON.stringify(response.error));
        //        } else {
        //            console.log("else");
        //            console.log(response);
        //            var fdata;
        //            var friendIDs = [];
        //            // var data = document.getElementById('data');
        //            // fdata = response.data;
        //            //console.log("fdata: " + fdata);
        //            //  var dt = "";
        //            // response.data.forEach(function (item) {
        //            // var d = document.createElement('div');

        //            // dt = dt + item.name + "<img src=" + item.picture.data.url + "/>";
        //            // data.appendChild(d);                      
        //            // });
        //            //vm.friendinfo = dt;
        //        }
        //        var friends = response.data;
        //        console.log(friends.length);
        //        for (var k = 0; k < friends.length && k < 200; k++) {
        //            var friend = friends[k];
        //            var index = 1;

        //            friendIDs[k] = friend.id;
        //            console.log(friend.id);
        //            console.log(friend.name);


        //            var output = '';
        //            output += '<img src="' + friend.picture.data.url + '" width="25" height="25"></img>';
        //            output += ' ' + friend.name + '<br/>';
                    
        //            console.log(output);

        //            vm.friendinfo = output;


        //            //  fdata = fdata + "friend.name"
        //            //friendsInfo[k] = friend;
        //        }



        //    });


        //}

        activate();

        function activate() {
           
          //  var promises = [getDoctorSetupMode(), getInfoForAddMoreDoctors()];
            var promises = [];
            common.activateController(promises, controllerId);
            //.then(function () { log('Activated Registration View'); });
        }

        vm.login = function () {
            $location.path('/login');
        }

        vm.register = function () {
            $location.path('/register');
        }



        vm.redirectToSearch = function () {
            //alert("dfc" + vm.customer.userLogin);
            if (vm.customer.userLogin == "") {
                logError('Please enter your email id', '', true);
            }
            else if (vm.customer.password == "") {
                logError('Please enter your password', '', true);
            }
            else {

                return datacontext.registration.login(vm.customer).then(function (response) {
                    if (response.success == true) {


                        //Set the properties
                        userService.getLoggedInUser().then(function myfunction() {
                            //userService.isLogged = true;
                            //userService.userName = response.firstName;
                            common.gaTrackEvent('Kare4u Login', 'Click Login', 'Kare4u');
                            $location.path('/dashboard');
                            //$location.path("/forgot_password");
                            datacontext.registration.saveUserDetails(response.firstName, response.consumerID); // not needed
                            logSuccess(response.message, '', true);
                        });
                    }
                    if (response.data.success == false) { 
                        logError(response.data.message, '', true);
                    }

                }, function (response) {
                    logError("There was a problem handling your request. Please contact support", '', true);
                    //vm.showMessage = response;
                });
            }

        }
        vm.forgotPassword = function () {
            $location.path("/forgot_password");
        }

        vm.logout = function () {
            return datacontext.registration.logout().then(function () {
                //return $scope.upcomingAppointmentsData = data;
                vm.showMessage = 'Successfully Logged Out';
            }, function (response) { vm.showMessage = response.data; });
            //$location.path('/search');
        }
        vm.tellUsMore = function () {
            $location.path("/tell_us_more");
        }
        vm.redirectToSpecifyDoctors = function () {
            $location.path("/specify_your_doctor");
        }
        vm.newValue = function (mycategory) {
            //var selectedCategory = mycategory;
            //alert(selectedCategory);
        }

        vm.validateEmail = function () {
            var atpos = $scope.consumer.UserLogin.indexOf("@");
            var dotpos = $scope.consumer.UserLogin.lastIndexOf(".");
            if (atpos < 1 || dotpos < atpos + 2 || dotpos + 2 >= $scope.consumer.UserLogin.length) {
                vm.registrationStatus.userLoginStatus = false;
                logError("Please enter a valid e-mail address", '', true);
            }
            else {
                vm.registrationStatus.userLoginStatus = true;
            }          
        }
        vm.validateLoginEmail = function () {
            var atpos = vm.customer.userLogin.indexOf("@");
            var dotpos = vm.customer.userLogin.lastIndexOf(".");
            if (atpos < 1 || dotpos < atpos + 2 || dotpos + 2 >= vm.customer.userLogin.length) {
                logError("Please enter a valid e-mail address", '', true);
            }

        }
        vm.validateLoginPassword = function () {
            if (vm.customer.password.length < 6) {
                logError("Password must be more than 6 character.", '', true);
            }
        }
        vm.validatePassword = function () {
            if ($scope.consumer.Password.length <6) {
                vm.registrationStatus.passwordStatus = false;
                logError("Password must be more than 6 character.", '', true);
            }
            else {
                vm.registrationStatus.passwordStatus = true;
            }
        }
        vm.validateContact = function () {
            var textBox = document.getElementById("registercontact");
            var textLength = textBox.value.length;
            if (textLength < 10) {
                vm.registrationStatus.contactStatus = false;
                logError("Contact must be 10 digit.", '', true);
            }
            else {
                vm.registrationStatus.contactStatus = true;
            }
        }
        vm.registerUser = function (registrationDetails) {
            //UserLogin: '',
            //FirstName: '',
            //Contact: '',
            //Password:'',
            //DateOfBirth: ''
            if (registrationDetails.UserLogin == "" || registrationDetails.FirstName == ""
                || registrationDetails.Contact == "" || registrationDetails.Password == "" || registrationDetails.DateOfBirth == "") {
                logError('Please fill up all the fields', '', true);
            }
                
            else {
                
                if (vm.registrationStatus.userLoginStatus == true && vm.registrationStatus.passwordStatus == true && vm.registrationStatus.contactStatus == true) {

                    registeredUserInfo.FirstName = registrationDetails.FirstName;
                    registeredUserInfo.DateOfBirth = registrationDetails.DateOfBirth;
                    return datacontext.registration.registerUser(registrationDetails).then(function (data) {

                        if (data.success == true) {
                            //Set the properties
                            registeredUserInfo.PatientBasicInfoID = data.consumer.consumerBasicInfo.patientBasicInfoID;
                            //datarepo.commonrepo.saveKare4uRegisterdUserDetails(data);
                            userService.getLoggedInUser().then(function () {
                                logSuccess('Registration Successful', '', true);
                                $location.path("/tell_us_more");
                                vm.registrationMessage = data;
                                return vm.registrationMessage;
                            });
                        }
                        else{
                            for (var i = 0 ; i < data.data.length; i++) {
                                logError(data.data[i], '', true);
                            }
                        }

                        //userService.isLogged = true;
                        //userService.userName = registrationDetails.FirstName;

                    }, function (response) {
                        logError('Registration Failed.', '', true);
                        //vm.registrationMessage = response.data;
                        //alert("Validation failed.Check your details!");
                    });
                }
                else {
                    logError('Please validate all the fields.', '', true);
            }
                



                }

        }
        vm.getSearchedDoctors = function (term) {
            return datacontext.search.getSearchedDoctors(term).$promise.then(function (result) {
                return result;
            });
        }

    }
})();