﻿(function () {
    'use strict';

    // Factory name is handy for logging
    var serviceId = 'repositories';

    // Define the factory on the module.
    // Inject the dependencies. 
    // Point to the factory definition function.
    // TODO: replace app with your module name
    angular.module('app').factory(serviceId, ['$injector','$http', repositories]);

    function repositories($injector,$http) {
        // Define the functions and properties to reveal.
        var service = {
            getRepo: getRepo
        };

        return service;

        // Get named Repository Ctor (by injection), new it, and initialize it
        function getRepo(repoName) {
            var fullRepoName = 'repository.' + repoName.toLowerCase();
            var Repo = $injector.get(fullRepoName);
            return new Repo();
        }

        //#region Internal Methods        

        //#endregion
    }
})();