﻿(function () {
	'use strict';

	// Factory name is handy for logging
	var serviceId = 'repository.digitallocker';

	angular.module('app').factory(serviceId, ['repository.abstract', RepositoryDigitalLocker]);

	function RepositoryDigitalLocker(AbstractRepository) {

		// Define the functions and properties to reveal.
		function Ctor() {
			this.serviceId = serviceId;
			// Exposed data access functions
			this.setInfoForAddMoreDoctors = setInfoForAddMoreDoctors;
			//this.GetFileTypeList = GetFileTypeList;
			this.saveDitaldocument = saveDitaldocument;
			this.GetMyUploadedDocuments = GetMyUploadedDocuments;
			this.saveDitaldocument1 = saveDitaldocument1;
			this.downloadDocument = downloadDocument;
			this.getUploadDetailsBeforeupload = getUploadDetailsBeforeupload;
			this.DeleteDigitalDocument = DeleteDigitalDocument;
		}

		AbstractRepository.extend(Ctor);
		return Ctor;
		function setInfoForAddMoreDoctors(addMoreDoctorsPageInfo) {
			addMoreDoctorsInfo = addMoreDoctorsPageInfo;
		}
		//function GetFileTypeList(type) {
		//    var self = this;
		//    var data = {
		//        standardCode: type
		//    }
		//    return self.getwithparm('api/Utility/GetDropDownValuesFor', data);
		//}
		function getUploadDetailsBeforeupload(filename,contentType) {
		    var self = this;
		    
		   // return self.get('api/ConsumerPHR/GetUploadDetailsBeforeupload');

		    var data = {
		        Filename: filename,
		        ContentType: contentType
		    }
		    return self.getwithparm('api/ConsumerPHR/GetS3PolicyDetails', data);
		}
		function GetMyUploadedDocuments() {
		    var self = this;

		    return self.get('api/ConsumerPHR/RetriveConsumerDigitalDocuments');
		}
		function downloadDocument(param) {
		    var self = this;
		    //var data = {
		    //    filePath: documentPath
		    //}
		    return self.getfilewithparm('api/ConsumerPHR/DownloadFileFromAWS', param);
            
		}
		function DeleteDigitalDocument(DigitalDocumentsID) {
		    var self = this;
		    var data = {
		        ConsumerDigitalDocumentsID: DigitalDocumentsID
		    }
		   
		    return self.saveNew('api/ConsumerPHR/DeleteDigitalDocument', data);

		}
		function saveDitaldocument(fileContent) {
		    var self = this;
		    var data = {
		        FileContent: fileContent.FileData,
		        FileName: fileContent.FileName,
		        DocumentFor: fileContent.FileForKey,
		        DocumentType: fileContent.FileTypeKey,
		        FileDescription: fileContent.FileDescription,
		        FileExtension: fileContent.FileExtension
		        
		    }

		   
		    return self.saveNew('api/ConsumerPHR/UploadDigitalDocumentForMobile', data);
		}
		function saveDitaldocument1(fileContent) {
		    var self = this;
		    var data = {
		        files: fileContent

		    }
		    return self.saveNew('api/ConsumerPHR/UplaodDigitalDocuments', data);
		}
		
	}
})();