﻿(function () {
    'use strict';

    // Factory name is handy for logging
    var serviceId = 'searchCriteria';

    // Define the factory on the module.
    // Inject the dependencies. 
    // Point to the factory definition function.
    // TODO: replace app with your module name
    angular.module('app').factory(serviceId, ['$q', 'datacontext', searchCriteria]);

    function searchCriteria($q, datacontext) {
        // Define the functions and properties to reveal.
        var searchCriteriaOb = {
            cityId: 0,
            specializationId: 0,
            specializationName:'',
            doctorName: '',
            cityName: '',
            //locationname:'',
            lattitude: '',
            longitude: '',
            isAutocomplete: false,
            pageIndex: 0,
            firstTime: false,
            searchBy: '',
            locationAvailable: false,
            cityAreaFacet: '',
            specialisationFacet:''
        };

        return searchCriteriaOb;


        //#region Internal Methods        

        //#endregion
    }
})();