﻿(function () {
    'use strict';
    var controllerId = 'myPreviousSuggestions';
    angular.module('app').controller(controllerId, ['common', '$scope', '$location', '$rootScope', 'datacontext', myPreviousSuggestions]);

    function myPreviousSuggestions(common, $scope, $location, $rootScope, datacontext) {
        var vm = this;
        var getLogFn = common.logger.getLogFn;
        var log = getLogFn(controllerId);
        vm.processedSuggestions = 0;
        vm.pendingSuggestions = 0;
        activate();

        function getPreviousSuggestions() {
            return datacontext.appointment.getPreviousDoctorSuggestions().then(function (httpResponse) {
                console.log(httpResponse);
                vm.prevSuggestionInfo = httpResponse;
                for (var i = 0; i < vm.prevSuggestionInfo.length; i++) {
                    if (vm.prevSuggestionInfo[i].status == 5197 || vm.prevSuggestionInfo[i].status == 5198 || vm.prevSuggestionInfo[i].status == 5199) {
                        vm.processedSuggestions++;
                    }
                    else if (vm.prevSuggestionInfo[i].status == 5196) {
                        vm.pendingSuggestions++;
                    }

                }
                console.log("Processed suggestions = "+vm.processedSuggestions + " | " + "Pending suggestions = "+vm.pendingSuggestions);
            });
        }
        

        function activate() {
            var promises = [getPreviousSuggestions()];
            common.activateController(promises, controllerId);
        }

    }
})();