(function () {
    'use strict';

    var app = angular.module('app');

    // Configure Toastr
    toastr.options.timeOut = 4000;
    toastr.options.positionClass = 'toast-bottom-right';

    // For use with the HotTowel-Angular-Breeze add-on that uses Breeze
    var remoteServiceName = 'breeze/Breeze';
   var remoteServiceURL = '';

  //  var remoteServiceURL = 'http://localhost\\:8088/';
    //var remoteServiceURL = 'http://54.204.12.176\\:8087/';
  //var remoteServiceURL = 'http://mobile.kare4u.in/';

   if (!window.cordova) {
      // remoteServiceURL = 'http://localhost:11454/';
       remoteServiceURL = '/';
   }
   else {
       remoteServiceURL = 'https://mobile.kare4u.in:1024/';
   }
    //Local Storage Names

    var localStorageNames = {
        upcomingAppointments: 'upcomingAppointments',
        pastAppointments: 'pastAppointments',
        familyMembers: 'familyMembers',
        loggedOnConsumerDetails: 'loggedOnConsumerDetails',
        suggestedDoctors: 'suggestedDoctors',
        familyamembersForDropdown: 'familyamembersForDropdown',
        favouriteDoctorsList: 'favouriteDoctorsList',
        availableCities: 'availableCities',
        childrenList: 'childrenList'
    }

    var events = {
        controllerActivateSuccess: 'controller.activateSuccess',
        spinnerToggle: 'spinner.toggle'
    };

    var config = {
        appErrorPrefix: '[Kare4U Error] ', //Configure the exceptionHandler decorator
        docTitle: 'Kare4U: ',
        events: events,
        remoteServiceName: remoteServiceName,
        version: '2.0.0',
        remoteServiceURL: remoteServiceURL,
        localStorageNames: localStorageNames
    };

    app.value('config', config);

    app.config(['$logProvider', function ($logProvider) {
        // turn debugging off/on (no info or warn)
        if ($logProvider.debugEnabled) {
            //$logProvider.debugEnabled(true);
            $logProvider.debugEnabled(false);
        }
    }]);

    //#region Configure the common services via commonConfig
    app.config(['commonConfigProvider', function (cfg) {
        cfg.config.controllerActivateSuccessEvent = config.events.controllerActivateSuccess;
        cfg.config.spinnerToggleEvent = config.events.spinnerToggle;
    }]);
    //#endregion
})();