﻿(function () {
    'use strict';
    var controllerId = 'addmoredoctors';
    angular.module('app').controller(controllerId, ['common', 'datacontext','datarepo', '$scope', '$location', '$rootScope', addmoredoctors ]);

    function addmoredoctors(common, datacontext,datarepo, $scope, $location, $rootScope) {
        var getLogFn = common.logger.getLogFn;
        var logSuccess = getLogFn(controllerId, 'success');
        var logError = getLogFn(controllerId, 'error');
        var vm = this;
        vm.title = 'Add more doctors';
        //vm.infoForAddMoreDoctorsPage;
        vm.doctorsInfo = [];
        var favouriteListCriteria = {};
        vm.doctorsInfo;
      //  var favouriteListParams;
        //var paramsForSaveFavourite;
       // var favListSuccessMessage;

        activate();

        function activate() {
            var promises = [ getFavouriteListFilterInfo()];
            common.activateController(promises, controllerId);
                //.then(function () { log('Activated Add More Doctors View'); });
        }

        $scope.toggleFavDoctorDetail = function ($index) {
            
            $scope.activefavPosition = $scope.activefavPosition == $index ? -1 : $index;
           
        };


        function getFavouriteListFilterInfo() {

           // var autocompleteResult = datarepo.commonrepo.getAutocompleteResult();
           // autocompleteResult.doctorName = $("#specialistAutocompleteRes").val();
           // autocompleteResult.doctorLoc = vm.selectedDemographyCode;
           // datarepo.commonrepo.saveAutocompleteResult(autocompleteResult);

           // favouriteListCriteria = datarepo.commonrepo.getFavouriteListFilterInfo();
           // console.log(favouriteListCriteria);
            //favouriteListParams = {
            //    searchParam:favouriteListCriteria.doctorName,
            //    specializationID: favouriteListCriteria.specializationId,
            //    cityID: favouriteListCriteria.cityId,
            //    cityName:favouriteListCriteria.cityName,
            //    IsAutocomplete: false
            //}
            //console.log(favouriteListParams);
            //return datacontext.registration.getDoctorsInfo(favouriteListParams).then(function (result) {
            return datacontext.registration.getDoctorsInfo().then(function (result) {
                //if (result[0].providerSearchDetails.length) {
                //}
                //else {
                //}
                vm.doctorsInfo = result;
               
                return vm.doctorsInfo;
            });
        }
        vm.goToSuggestDoc = function () {
            $location.path('/suggest');
        }
        vm.addToFavouriteList = function (Index) {
            var saveToFavourite = {
                //specializationID:'',
                //specializationName:vm.doctorsInfo[0].providerSearchDetails[Index].doctorSpecialization[0].description,
                providerID:vm.doctorsInfo[0].providerSearchDetails[Index].providerID
               // providerName: vm.doctorsInfo[0].providerSearchDetails[Index].name,
               // cityCode: favouriteListParams.cityID,
               // city: favouriteListParams.cityName
            };
            console.log(saveToFavourite);
            return datacontext.registration.saveToFavourites(saveToFavourite).then(function (response) {
                //logSuccess(data.message, "", true);
                logSuccess(response.message, "", true);
                //favListSuccessMessage = data;
                $location.path("/choose_your_doctor");
                //return favListSuccessMessage;
            }, function (response) {
                logError(response.message, "", true);
               // favListSuccessmessage = response.data;
            });
        }
    }
})();